// #autoload
// #name = DioVolumeHUD
// #version = 1.0
// #date = 9/20/2002 5:32AM
// #status = release
// #author = |Rx|Diogenes
// #warrior = Diogenes
// #email = diogenes@tribalpharmacy.com
// #web = http://www.tribalpharmacy.com
// #description = Press the DioVolumeHUD key to launch the HUD, use your mousewheel to adjust the volume.
// #category = DioScripts
// #credit = Halide, for coming up with a great idea for me to rip :D

if(!isObject(DioVolumeHUD))
{
	new ScriptObject(DioVolumeHUD)
	{
		class = DioVolumeHUD;
	};
}

package DioVolumeHUD {

	function DioVolumeHUD::Setup(%this){
		new actionMap(DioVHBinds);
		DioVHBinds.bind(mouse0, "zaxis", DioVolumeHUDAdjust);
	}

	function DioVolumeHUDAdjust(%val){
		if(%val > 0){
			$pref::Audio::masterVolume = $pref::Audio::masterVolume + 0.02;
		}
		else{
			$pref::Audio::masterVolume = $pref::Audio::masterVolume - 0.02;
		}
		if($pref::Audio::masterVolume > 1) $pref::Audio::masterVolume = 1;
		if($pref::Audio::masterVolume < 0) $pref::Audio::masterVolume = 0;
		%vol = mfloor($pref::Audio::masterVolume * 100);
		diovhbar.setvalue(%vol / 100);
		diovhpercent.settext(%vol @ "%");
		alxListenerf( AL_GAIN_LINEAR, $pref::Audio::masterVolume );
	}

	function DioVolumeHUDShow(%val){
		if(%val){
			%vol = mfloor($pref::Audio::masterVolume * 100);
			diovhbar.setvalue(%vol / 100);
			diovhpercent.settext(%vol @ "%");			
			DioVH.setvisible(true);
			DioVHBinds.push();
		}
		else{
			DioVH.setvisible(false);
			DioVHBinds.pop();
		}
	}
	
	function DioVolumeHUD::Create(%this){
		if(isobject(DioVH)){
			DioVH.delete();
		}
		
		new GuiControl(DioVH) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "50 200";
			extent = "200 35";
			minExtent = "8 8";
			visible = "0";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
		
			new GuiProgressCtrl(diovhbar) {
				profile = "BrowserProgressProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "10 5";
				extent = "180 25";
				minExtent = "0 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				useVariable = "0";
			};
			new GuiTextCtrl(diovhlabel) {
				profile = "ShellProgressBarTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "65 8";
				extent = "50 26";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Volume";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new GuiTextCtrl(diovhpercent) {
				profile = "ShellProgressBarTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "114 8";
				extent = "50 26";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "50%";
				longTextBuffer = "0";
				maxLength = "255";
			};
		};
		if (isObject(HM) && isObject(HudMover)){
			hudmover::addhud(DioVH, "DioVolumeHUD");
		}
		PlayGui.add(DioVH);
	}

	function LoadingGui::onWake(%this){
		if (!DioVolumeHUD.made)
		{
			DioVolumeHUD.Create();
			DioVolumeHUD.made = true;
		}
		parent::onWake(%this);
	}

	function OptionsDlg::onWake( %this ){
		if (!DioVolumeHUD.bound) {
			$RemapName[$RemapCount]="DioVolumeHUD";
			$RemapCmd[$RemapCount]="DioVolumeHUDShow";
			$RemapCount++;
			DioVolumeHUD.bound = true;
		}
		parent::onWake( %this );
	}
	
};

activatePackage(DioVolumeHUD);

if($AutoloadExecuted)
	DioVolumeHUD.Setup();